# rrwl.cf.sh
# Daily scheduled after rrwl.sh it prroduce rrwl.*.cf file and put into spamassassin private directory
# Put in cron after rrwl.sh
# 05 01 * * * /batch/rrwl.cf.sh


# Variables
F="/etc/mail/spamassassin"   # Spamassassin default dir
FT="/tmp"                    # Temp dir
APP="rrwl"                   # Application name
D=70                         # Days to search for whitelist files
SD=-1.03                     # Score to assign to Domain/Ip
SE=-1.04                     # Score to assign to Email/Ip
# General purpose domain list to use in single mail mode
singledomains=(alice.it \
               apple.com \
               email.it \
               gmail.com \
               hotmail.com \
               live.it \
               icloud.com \
               interfree.it \
               inwind.it \
               libero.it \
               me.com \
               ngi.it \
               omniway.sm \
               outlook.com \
               tin.it \
               aruba.it \
               tiscali.it \
               virgilio.it \
               vodafone.it \
               yahoo.it \
               yahoo.com \
               yahoo.ro \
              )





# START

# Display single mail mode domains
echo "Single email mode domain list :"
for i in ${singledomains[@]}; do
 echo " - "$i
done

# Check store dir & create
if [ ! -d $F/$APP ]; then
 mkdir $F/$APP
 chmod 777 $F/$APP
fi

# Processing DOMAIN
echo "Processing Domain"
cd $F/$APP
#pwd
# Merging files
rm -f $FT/$APP.domain.1.txt
for f in `find $F/$APP  -maxdepth 1 -type f -name $APP".domain.*" -print -mtime -$D` 
do
 #echo $f
 cat $f >> $FT/$APP.domain.1.txt
done
# Removing duplicates
sort -u $FT/$APP.domain.1.txt > $FT/$APP.domain.2.txt
# Removing general purpose domains
for i in ${singledomains[@]}; do
 sed -i.bak "/^"$i"/d" $FT/$APP.domain.2.txt
done
# Reading sorted file and write rule
rm -f $FT/$APP.domain.cf
sdomain="";rule="";g=0
while read -r line
do
 #echo $g $line
 ldomain=$(echo $line | awk '{print $1}')
 lip=$(echo $line | awk '{print $2}')
 if [ $g -eq 0 ]
 then 
  lldomain=$(echo $ldomain | sed -e "s/\./\_/g" | sed -e "s/\-/\_/g" )
  rule="header __RRWL_D_"$lldomain"_R Received =~ /"
  sdomain=$ldomain
 fi
 g=$[g+1]
 #echo $ldomain
 #echo $lip
 if [ "$ldomain" == "$sdomain" ]
 then
  llip=$(echo $lip| sed -e "s/\./\\\\./g")
  if [ $g -eq 1 ]
  then
   rule=$rule$llip
  else
   rule=$rule"|"$llip
  fi
 else
  ssdomain=$(echo $sdomain | sed -e "s/\./\\\\./g")
  sssdomain=$(echo $sdomain | sed -e "s/\./\_/g" | sed -e "s/\-/\_/g" )
  rule=$rule"/i"
  rule2="header __RRWL_D_"$sssdomain"_F From =~ /\@"$ssdomain"/i"
  rule3="meta RRWL_D_"$sssdomain" (__RRWL_D_"$sssdomain"_R&&__RRWL_D_"$sssdomain"_F)"
  rule4="describe RRWL_D_"$sssdomain" Reference White Listed Domain/Ip ["$sdomain"]"
  rule5="score RRWL_D_"$sssdomain" "$SD
  echo $rule   >> $FT/$APP.domain.cf
  echo $rule2  >> $FT/$APP.domain.cf
  echo $rule3  >> $FT/$APP.domain.cf
  echo $rule4  >> $FT/$APP.domain.cf
  echo $rule5  >> $FT/$APP.domain.cf
  echo " "     >> $FT/$APP.domain.cf
  lldomain=$(echo $ldomain | sed -e "s/\./\_/g" | sed -e "s/\-/\_/g" )
  llip=$(echo $lip| sed -e "s/\./\\\\./g")
  rule="header __RRWL_D_"$lldomain"_R Received  =~ /"$llip
  sdomain=$ldomain
 fi
done < $FT/$APP.domain.2.txt
ssdomain=$(echo $sdomain | sed -e "s/\./\\\\./g")
sssdomain=$(echo $sdomain | sed -e "s/\./\_/g" | sed -e "s/\-/\_/g" )
rule=$rule"/i"
rule2="header __RRWL_D_"$sssdomain"_F From =~ /\@"$ssdomain"/i"
rule3="meta RRWL_D_"$sssdomain" (__RRWL_D_"$sssdomain"_R&&__RRWL_D_"$sssdomain"_F)"
rule4="describe RRWL_D_"$sssdomain" Reference White Listed Domain/Ip ["$sdomain"]"
rule5="score RRWL_D_"$sssdomain" "$SD
echo $rule   >> $FT/$APP.domain.cf
echo $rule2  >> $FT/$APP.domain.cf
echo $rule3  >> $FT/$APP.domain.cf
echo $rule4  >> $FT/$APP.domain.cf
echo $rule5  >> $FT/$APP.domain.cf
echo " "     >> $FT/$APP.domain.cf


# Processing EMAIL
echo "Processing Email"
cd $F/$APP
#pwd
# Merging files
rm -f $FT/$APP.email.1.txt
rm -f $FT/$APP.email.3.txt
for f in `find $F/$APP  -maxdepth 1 -type f -name $APP".email.*" -print -mtime -$D` 
do
 #echo $f
 cat $f >> $FT/$APP.email.1.txt
done
# Removing duplicates
sort -u $FT/$APP.email.1.txt > $FT/$APP.email.2.txt
# Retaining only general purpose domains
for i in ${singledomains[@]}; do
 sed -n "/\@"$i"/p" $FT/$APP.email.2.txt >> $FT/$APP.email.3.txt
done




# Reading sorted file and write rule
rm -f $FT/$APP.email.cf
semail="";rule="";g=0
while read -r line
do
 #echo $g $line
 lemail=$(echo $line | awk '{print $1}')
 lip=$(echo $line | awk '{print $2}')
 if [ $g -eq 0 ]
 then 
  llemail=$(echo $lemail | sed -e "s/\./\_/g" | sed -e "s/\-/\_/g" | sed -e "s/\@/\_/g" )
  rule="header __RRWL_E_"$llemail"_R Received =~ /"
  semail=$lemail
 fi
 g=$[g+1]
 #echo $lemail
 #echo $lip
 if [ "$lemail" == "$semail" ]
 then
  llip=$(echo $lip| sed -e "s/\./\\\\./g")
  if [ $g -eq 1 ]
  then
   rule=$rule$llip
  else
   rule=$rule"|"$llip
  fi
 else
  ssemail=$(echo $semail | sed -e "s/\./\\\\./g")
  sssemail=$(echo $semail | sed -e "s/\./\_/g" | sed -e "s/\-/\_/g" | sed -e "s/\@/\_/g" )
  sssxemail=$(echo $semail | sed -e "s/\./\_/g" | sed -e "s/\-/\_/g" | sed -e "s/\@/\\\\@/g" )
  rule=$rule"/i"
  rule2="header __RRWL_E_"$sssemail"_F From =~ /"$sssxemail"/i"
  rule3="meta RRWL_E_"$sssemail" (__RRWL_E_"$sssemail"_R&&__RRWL_E_"$sssemail"_F)"
  rule4="describe RRWL_E_"$sssemail" Reference White Listed Email/Ip ["$semail"]"
  rule5="score RRWL_E_"$sssemail" "$SE
  echo $rule   >> $FT/$APP.email.cf
  echo $rule2  >> $FT/$APP.email.cf
  echo $rule3  >> $FT/$APP.email.cf
  echo $rule4  >> $FT/$APP.email.cf
  echo $rule5  >> $FT/$APP.email.cf
  echo " "     >> $FT/$APP.email.cf
  llemail=$(echo $lemail | sed -e "s/\./\_/g" | sed -e "s/\-/\_/g" | sed -e "s/\@/\_/g" )
  llip=$(echo $lip| sed -e "s/\./\\\\./g")
  rule="header __RRWL_E_"$llemail"_R Received  =~ /"$llip
  semail=$lemail
 fi
done < $FT/$APP.email.3.txt
ssemail=$(echo $semail | sed -e "s/\./\\\\./g")
sssemail=$(echo $semail | sed -e "s/\./\_/g" | sed -e "s/\-/\_/g" | sed -e "s/\@/\_/g" )
sssxemail=$(echo $semail | sed -e "s/\./\_/g" | sed -e "s/\-/\_/g" | sed -e "s/\@/\\\\@/g" )
rule=$rule"/i"
rule2="header __RRWL_E_"$sssemail"_F From =~ /"$sssxemail"/i"
rule3="meta RRWL_E_"$sssemail" (__RRWL_E_"$sssemail"_R&&__RRWL_E_"$sssemail"_F)"
rule4="describe RRWL_E_"$sssemail" Reference White Listed Email/Ip ["$semail"]"
rule5="score RRWL_E_"$sssemail" "$SE
echo $rule   >> $FT/$APP.email.cf
echo $rule2  >> $FT/$APP.email.cf
echo $rule3  >> $FT/$APP.email.cf
echo $rule4  >> $FT/$APP.email.cf
echo $rule5  >> $FT/$APP.email.cf
echo " "     >> $FT/$APP.email.cf


# Cleanup
echo "Cleanup tmp"
rm -f $FT/$APP.domain.1.txt
rm -f $FT/$APP.domain.2.txt
rm -f $FT/$APP.domain.2.txt.bak
rm -f $FT/$APP.email.1.txt
rm -f $FT/$APP.email.2.txt
rm -f $FT/$APP.email.3.txt

# Production move
echo "Production move"
chmod 777 $FT/$APP.domain.cf 
chmod 777 $FT/$APP.email.cf 
mv $FT/$APP.domain.cf $F
mv $FT/$APP.email.cf $F
service MailScanner restart

