# rrwl.sh
# Daily scheduled it prroduce a file compacting 2 days of Domain/Ip of senders that have been reverenced and put into store dir
# Put in cron after midnight to process yesterday
# 05 00 * * * /batch/rrwl.sh

# Variables
F="/etc/mail/spamassassin"   # Spamassassin default dir
FT="/tmp"                    # Temp dir
APP="rrwl"                   # Application name
DMIN=5                       # Minimun domain lenght to search for
DMAX=40                      # Maximum domain lenght to search for
LDIP=10.1.%                  # Local identification Ip to exclude from search
# Local domain lists for replyto/references search for
mydomains=(gruppocomet.it \
           agenti.gruppocomet.it \
           sime.gruppocomet.it \
           marinipandolfi.it \
           comet.it \
           vignuda.it \
          )




# START

# Building sql part based on local domain list
echo "Local domain list :"
vdsql="";g=0
for i in ${mydomains[@]}; do
 echo " - "$i
 if [ $g -eq 0 ]
 then
  vdsql=$vdsql"headers LIKE '%In-Reply-To:%@"$i"%Subject:%' "
  vdsql=$vdsql"OR headers LIKE '%References:%@"$i"%Subject:%' "
 else
  vdsql=$vdsql"OR headers LIKE '%In-Reply-To:%@"$i"%Subject:%' "
  vdsql=$vdsql"OR headers LIKE '%References:%@"$i"%Subject:%' "
 fi
 g=$[g+1]
done

# Check store dir & create
if [ ! -d $F/$APP ]; then
 mkdir $F/$APP
 chmod 777 $F/$APP
fi

# File Now
yesterday=$(date --date "-1 day" +"%Y%m%d")
yesterdayq=$(date --date "-1 day" +"%Y-%m-%d")

# File override to process older days manually
##yesterday="20160630"
##yesterdayq="2016-06-30"

echo "Processing daily 'domain' query into : " $F/$APP/$APP".domain."$yesterday
# SQL Command to Execute, modify inserting your domains, Your ip to exclude and date range to extract
vsql="SELECT from_domain, clientip FROM maillog "
vsql=$vsql"WHERE ( maillog.date = '"$yesterdayq"' ) "
vsql=$vsql"AND ( clientip NOT LIKE '"$LDIP"' ) "
vsql=$vsql"AND ( from_address NOT LIKE '%bounce%' ) "
vsql=$vsql"AND ( from_address NOT LIKE '%prvs%' ) "
vsql=$vsql"AND ( LENGTH(from_domain) > "$DMIN" ) "
vsql=$vsql"AND ( LENGTH(from_domain) < "$DMAX" ) "
vsql=$vsql"AND ( "
vsql=$vsql$vdsql
vsql=$vsql" ) "
vsql=$vsql" GROUP BY from_domain, clientip ;"
# SQL Execution 
#echo $vsql
echo $vsql | mysql -N -u root -pSSPTzzWQs6hEOpflSfI1CYt5Nr5h63 -D mailscanner > $F/$APP/$APP".domain."$yesterday

echo "Processing daily 'email' query into : " $F/$APP/$APP".email."$yesterday
# SQL Command to Execute, modify inserting your domains, Your ip to exclude and date range to extract
vsql="SELECT from_address, clientip FROM maillog "
vsql=$vsql"WHERE ( maillog.date = '"$yesterdayq"' ) "
vsql=$vsql"AND ( clientip NOT LIKE '"$LDIP"' ) "
vsql=$vsql"AND ( from_address NOT LIKE '%bounce%' ) "
vsql=$vsql"AND ( from_address NOT LIKE '%prvs%' ) "
vsql=$vsql"AND ( LENGTH(from_domain) > "$DMIN" ) "
vsql=$vsql"AND ( LENGTH(from_domain) < "$DMAX" ) "
vsql=$vsql"AND ( "
vsql=$vsql$vdsql
vsql=$vsql" ) "
vsql=$vsql" GROUP BY from_address, clientip ;"
# SQL Execution 
#echo $vsql
echo $vsql | mysql -N -u root -pSSPTzzWQs6hEOpflSfI1CYt5Nr5h63 -D mailscanner > $F/$APP/$APP".email."$yesterday

